<template>
  <label :class="{ error }">
    {{ label }}
    <div class="input-wrapper">
      <input
        v-bind="$attrs"
        v-on="{
          ...$listeners,
          input: (event) => $emit('input', event.target.value),
        }"
        :class="{ append, error, nav }"
        :value="value"
        v-mask="mask"
      />
      <img v-if="append" :src="getImgUrl(append)" alt="" />
    </div>
    <p class="error">
      {{ error }}
    </p>
  </label>
</template>

<script lang="ts">
import { defineComponent } from '@vue/composition-api';

export default defineComponent({
  name: 'Input',

  props: {
    label: {
      type: String,
      default: '',
    },
    value: {},
    append: {
      type: String,
      default: '',
    },
    error: {
      type: String,
      default: '',
    },
    nav: {
      type: Boolean,
      default: false,
    },
    mask: {
      type: String,
      default: '',
    },
  },

  setup() {
    const getImgUrl = (path: string) => {
      var images = require.context('@/assets/icons', false);
      return images(`./${path}.svg`);
    };

    return { getImgUrl };
  },
});
</script>

<style scoped lang="scss">
@import './Input.scss';
</style>
